﻿using System;
using XF.Common.Core;
using XF.Common.Core.Server;
using XF.Common.Map;
using XF.Common.Repositories;
using XF.Common.Server.Core.Repositories;
using XF.Common.Server.Core.VM.GasStation;
using ServiceLifetime = XF.Common.Core.ServiceLifetime;

namespace XF.Common.Server
{
    /// <summary>
    /// 站点业务模块
    /// </summary>
    [ServiceDescription(typeof(ISiteServer), ServiceLifetime.Scoped)]
    public class SiteServer : ISiteServer
    {

        public IBusinessUnitInfoReponse _businessUnitInfoReponse;
        public SiteServer(IBusinessUnitInfoReponse businessUnitInfoReponse)
        {
            _businessUnitInfoReponse = businessUnitInfoReponse;
        }

        /// <summary>
        /// 获取父级BU参数
        /// </summary>
        /// <returns></returns>
        public async Task<IEnumerable<SiteListVm>> GetParentBUData()
        {
           var list=await _businessUnitInfoReponse.GetListAsync(k=>string.IsNullOrWhiteSpace(k.parent_bu_id));
            return list.ToDTOList<SiteListVm>();
          
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="buid"></param>
        /// <returns></returns>
        /// <exception cref="NotImplementedException"></exception>
        public async Task<IEnumerable<SiteListVm>> GetStie(string buid)
        {
            var list = await _businessUnitInfoReponse.GetListAsync(k =>k.business_unit_info_id==buid);
            return list.ToDTOList<SiteListVm>();
        }

        /// <summary>
        /// 
        /// </summary>
        /// <param name="parBuid"></param>
        /// <returns></returns>
        /// <exception cref="NotImplementedException"></exception>
        public async Task<IEnumerable<SiteListVm>> GetStieByParBuid(string parBuid)
        {
            var list = await _businessUnitInfoReponse.GetListAsync(k => k.parent_bu_id == parBuid);
            return list.ToDTOList<SiteListVm>();
        }


        /// <summary>
        /// 
        /// </summary>
        /// <param name="Model"></param>
        /// <returns></returns>
        /// <exception cref="NotImplementedException"></exception>
        public async Task<bool> SaveSite(SiteSaveVm Model)
        {
            return true;
        }
    }
}
